from psage.modform.hermitianmodularforms.hermitianmodularformd2_borcherdsproducts import *

## This form has precision 211, which is exactly the precision required according to
## our theorem.
F = load("borcherds_example_input_data.sobj")

B = 11; D = -3
prec = HermitianModularFormD2Filter_diagonal(B, D)
phi = borcherds_product__by_logarithm(F, prec)

ch = phi.parent().characters().one_element()
save(phi.coefficients()[ch], "borcherds_example_phi_coefficients.sobj")

prec_nr = phi.parent().monoid().filter(B)
mf_expansion = dict( enumerate(2*B * [0]) )
for (a, b1, b2, c) in prec_nr :
  mf_expansion[a + c] += phi[(ch, (a, b1, b2, c))]

mfs = ModularForms(1, F[(0,0)][0] / 2)
mfs(PowerSeriesRing(QQ, 'q')(mf_expansion).add_bigoh(B))

